<template>
  <div class="change-password">
    <p class="change-password--title title-medium">Mot de passe</p>
    <a-form
      :colon="false"
      hideRequiredMark
      ref="formRef"
      class="change-password--form"
      name="custom-validation"
      validateOnRuleChange
      :model="formState"
      :rules="rules"
    >
      <a-form-item name="oldPass" label="Mot de passe actuel *">
        <a-input-password
          placeholder="************"
          v-model:value="formState.oldPass"
          type="password"
          autocomplete="off"
        >
          <template #prefix>
            <lock-outlined />
          </template>
        </a-input-password>
      </a-form-item>
      <a-form-item name="pass" label="Nouveau mot de passe *">
        <a-input-password
          @focus="showValidations = true"
          @blur="showValidations = false"
          v-model:value="formState.pass"
          placeholder="************"
        >
          <template #prefix>
            <lock-outlined />
          </template>
        </a-input-password>
        <div style="position: relative">
          <div class="change-password--validation" v-if="showValidations">
            <div>
              <p class="title">Le nouveau mot de passe doit contenir :</p>
              <ul class="change-password--validation-list">
                <li v-for="(validation, index) in validations" :key="index">
                  <check-circle-filled
                    v-if="formState.pass.match(validation.pattern)"
                  />
                  <close-circle-outlined v-else />
                  <span class="title">{{ validation.message }}</span>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </a-form-item>
      <a-form-item
        name="checkPass"
        label="Confirmation du nouveau mot de passe *"
      >
        <a-input-password
          placeholder="************"
          v-model:value="formState.checkPass"
          type="password"
          autocomplete="off"
        >
          <template #prefix>
            <lock-outlined />
          </template>
        </a-input-password>
      </a-form-item>
    </a-form>
    <div class="change-password--error">
      <p class="title" v-for="(error, index) in errors" :key="index">
        {{ error }}
      </p>
    </div>
    <a-button class="ant-btn ant-btn-purple" @click="onSubmit">
      Enregistrer
    </a-button>
  </div>
</template>

<script setup lang="ts">
import { passwordValidator } from '@/shared/composables/passwordValidator';
import { errorValidator } from '@/shared/composables/errorValidator';
import { ref } from 'vue';
import {
  LockOutlined,
  CloseCircleOutlined,
  CheckCircleFilled,
} from '@ant-design/icons-vue';

const formRef = ref();
let showValidations = ref<boolean>(false);
let { customRules, customValidations, errors, formState } = passwordValidator();
let { getErrors } = errorValidator();
const rules = {
  ...customRules,
  oldPass: {
    required: true,
    message: 'Veuiller saisir tous les champs obligatoires',
  },
};
const validations = customValidations;

const onSubmit = (): void => {
  formRef.value
    .validateFields(Object.keys(rules))
    .then(() => {
      errors.value = [];
      //  send request
    })
    .catch(
      (err: {
        errorFields: { errors: string[]; name: string[]; warnings: string[] }[];
      }) => {
        errors.value = getErrors(err.errorFields);
      }
    );
};
</script>
<script lang="ts">
export default {
  name: 'update-password',
};
</script>

<style scoped lang="scss">
@import '@/assets/styles/components/forms';
.change-password {
  &--title {
    margin-top: 54px;
    margin-bottom: 16px;
  }
  &--form {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    gap: 16px;
    .ant-form-item {
      width: 100%;
    }
  }
  &--validation {
    position: absolute;
    top: -6px;
    background: #ffffff;
    display: flex;
    align-items: center;
    justify-content: center;
    width: 321px;
    height: 140px;
    padding: 16px;
    box-shadow: 0 4px 24px #e5e5e5;
    @include validation-list;
  }
  &--error {
    margin-bottom: 16px;
    p {
      color: #eb5757;
      margin-bottom: 8px;
      &:first-letter {
        text-transform: capitalize;
      }
    }
  }
}
</style>
